#include <stdio.h>
#include <math.h>
#include <map>

using namespace std;

#define NMAX 201

/*
map<int, double> prob[2][NMAX];
map<int, double>::iterator it;
*/

#define ZERO 200
double prob[2][NMAX][2 * NMAX];

int p[NMAX], a[NMAX];
int i, N, L, K, c, nwon;
double pp, sump, goodp;

int main() {
	//freopen("x.txt", "r", stdin);
	scanf("%d %d %d", &N, &L, &K);

	for (i = 1; i <= N; i++)
		scanf("%d", &p[i]);
	for (i = 1; i <= N; i++)
		scanf("%d", &a[i]);

	memset(prob, 0, sizeof(prob));
	prob[0][0][min(K, N) + ZERO] = 1.0;
	
	for (i = 1; i <= N; i++) {
		pp = (double) p[i] / 100.0;
		c = i % 2;
		
		/*
		for (nwon = 0; nwon < i; nwon++)
			prob[c][nwon].clear();
		*/
		memset(prob[c], 0, sizeof(prob[c]));
		
		for (nwon = 0; nwon < i; nwon++)
			/*
			for (it = prob[1 - c][nwon].begin(); it != prob[1 - c][nwon].end(); it++) {
				int available_capacity = it->first;
			*/
			for (int available_capacity = -(i - 1); available_capacity <= N; available_capacity++) {
				//double probability = it->second;
				double probability = prob[1 - c][nwon][available_capacity + ZERO];
				
				// Lose contest #i.
				prob[c][nwon][available_capacity + ZERO] += probability * (1.0 - pp);

				// Win contest #i.
				prob[c][nwon + 1][min(available_capacity + a[i], N) + ZERO] += probability * pp;				
			}
	}

	c = N % 2;
	goodp = 0.0;
	for (nwon = L; nwon <= N; nwon++)
		/*
		for (it = prob[c][nwon].begin(); it != prob[c][nwon].end(); it++)
			if (it->first >= 0)
		*/
		for (int available_capacity = 0; available_capacity <= N; available_capacity++)
			//goodp += it->second;
			goodp += prob[c][nwon][available_capacity + ZERO];

	printf("%.9lf\n", goodp);
	return 0;
}
