#include <stdio.h>
#include <queue>

using namespace std;

#define NMAX 100100
#define INF 1000000000

char s[2][NMAX];
int tmin[2][NMAX];
int n, k, i, j;

int main() {
	//freopen("198B.txt", "r", stdin);
	scanf("%d %d %s %s", &n, &k, s[0] + 1, s[1] + 1);
	
	for (i = 1; i <= n; i++)
		tmin[0][i] = tmin[1][i] = INF;
	
	queue<pair<int, int> > q;
	q.push(make_pair(0, 1));
	tmin[0][1] = 0;
	
	while (q.size() > 0) {
		pair<int, int> p = q.front();
		q.pop();
		
		if (p.second < n && s[p.first][p.second + 1] == '-' && tmin[p.first][p.second + 1] == INF) {
			tmin[p.first][p.second + 1] = tmin[p.first][p.second] + 1;
			q.push(make_pair(p.first, p.second + 1));
		}

		if (p.second > 0 && s[p.first][p.second - 1] == '-' &&
			tmin[p.first][p.second - 1] == INF &&
			tmin[p.first][p.second] + 1 < p.second - 1) {
			tmin[p.first][p.second - 1] = tmin[p.first][p.second] + 1;
			q.push(make_pair(p.first, p.second - 1));
		}

		if (p.second <= n - k && s[1 - p.first][p.second + k] == '-' && tmin[1 - p.first][p.second + k] == INF) {
			tmin[1 - p.first][p.second + k] = tmin[p.first][p.second] + 1;
			q.push(make_pair(1 - p.first, p.second + k));
		}
	}
	
	for (i = 0; i <= 1; i++)
		for (j = n; j > n - k; j--)
			if (tmin[i][j] < INF) {
				printf("YES\n");
				return 0;
			}
	
	printf("NO\n");
	return 0;
}
