#include <stdio.h>

#define XMAX 101
#define NMAX 21

int nmin[XMAX];

void precompute() {
	for (int i = 0; i < XMAX; i++)
		nmin[i] = NMAX;
	nmin[0] = nmin[1] = 1;
	
	for (int n = 3; n < NMAX; n++) {
		int xmax, nbase = n - (n / 2);
		if (n % 2 == 0) {
			nbase--;
			if (nbase % 2 == 0)
				xmax = 4 * nbase * (nbase / 2);
			else
				xmax = 4 * ((nbase / 2) * (nbase / 2) + (nbase - nbase / 2) * (nbase - nbase / 2));

			fprintf(stderr, "n=%d, xmax=%d\n", n, xmax);

			for (int x = xmax; x >= 0; x -= 4)
				if (nmin[x] > n)
					nmin[x] = n;
		} else {
			xmax = (n / 2) * (n / 2) + (n - n / 2) * (n - n / 2);
			int cntcenter = 1;
			int cntmid;
			if (nbase % 2 == 0)
				cntmid = 2 * (nbase / 2 - 1);
			else
				cntmid = 2 * (nbase - nbase / 2 - 1);

			for (int remcntcenter = 0; remcntcenter <= cntcenter; remcntcenter++)
				for (int remcntmid = 0; remcntmid <= cntmid; remcntmid++)
					for (int x = xmax - remcntcenter - 2 * remcntmid; x >= (cntmid - remcntmid) * 2 + (cntcenter - remcntcenter); x -= 4)
						if (nmin[x] > n)
							nmin[x] = n;
			
			xmax = 2 * (n / 2) * (n - n / 2);
			cntcenter = 0;
			cntmid = 2 * (nbase / 2);
			for (int remcntcenter = 0; remcntcenter <= cntcenter; remcntcenter++)
				for (int remcntmid = 0; remcntmid <= cntmid; remcntmid++)
					for (int x = xmax - remcntcenter - 2 * remcntmid; x >= (cntmid - remcntmid) * 2 + (cntcenter - remcntcenter); x -= 4)
						if (nmin[x] > n)
							nmin[x] = n;
		}
	}
	
	for (int x = 1; x < XMAX; x++)
		fprintf(stderr, "x=%d => nmin=%d\n", x, nmin[x]);
}

int main() {
	int x;
	precompute();
	scanf("%d", &x);
	printf("%d\n", nmin[x]);
	return 0;
}
