#include <stdio.h>

#define NMAX 1000111
#define MOD 1000000007LL

char s[NMAX];
long long b[NMAX], w[NMAX], stotal[NMAX], p2[NMAX], sum, answer;
int N, K, i, nx, nw, nb, tnx, p2nx;

int main() {
	//freopen("x.txt", "r", stdin);
	scanf("%d %d %s", &N, &K, s + 1);

	tnx = nx = nw = 0;
	sum = stotal[0] = 0;
	p2[0] = 1;

	for (i = 1; i <= N; i++) {
		p2[i] = (p2[i - 1] * 2) % MOD;
		b[i] = 0;

		if (s[i] == 'X') {
			nx++;
			tnx++;
		} else if (s[i] == 'W') {
			nw++;
		}

		if (i > K) {
			if (s[i - K] == 'X') {
				nx--;
			} else if (s[i - K] == 'W') {
				nw--;
			}
			sum = (sum - b[i - K] + MOD) % MOD;
		}
		
		if (i >= K && nw == 0) {
			b[i] = (p2[tnx - nx] - sum - stotal[i - K] + 2 * MOD) % MOD;
		}

		stotal[i] = stotal[i - 1];
		if (s[i] == 'X') {
			stotal[i] = (stotal[i] * 2) % MOD;
		}
		
		sum = (sum + b[i]) % MOD;
		stotal[i] = (stotal[i] + b[i]) % MOD;
		//fprintf(stderr, "i=%d: b=%I64d stotal=%I64d\n", i, b[i], stotal[i]);
	}

	tnx = nx = nb = 0;
	sum = stotal[N + 1] = answer = 0;
	
	for (i = N; i >= 1; i--) {
		w[i] = 0;

		if (s[i] == 'X') {
			nx++;
			tnx++;
		} else if (s[i] == 'B') {
			nb++;
		}

		if (i <= N - K) {
			if (s[i + K] == 'X') {
				nx--;
			} else if (s[i + K] == 'B') {
				nb--;
			}
			sum = (sum - w[i + K] + MOD) % MOD;
		}
		
		if (i <= N - K + 1 && nb == 0) {
			w[i] = (p2[tnx - nx] - sum - stotal[i + K] + 2 * MOD) % MOD;
		}

		stotal[i] = stotal[i + 1];
		if (s[i] == 'X') {
			stotal[i] = (stotal[i] * 2) % MOD;
		}
		
		sum = (sum + w[i]) % MOD;
		stotal[i] = (stotal[i] + w[i]) % MOD;
		
		answer = (answer + stotal[i - 1] * w[i]) % MOD;
		
		//fprintf(stderr, "i=%d: w=%I64d stotal=%I64d\n", i, w[i], stotal[i]);
	}
	
	printf("%I64d\n", answer);
	return 0;
}
