#include <stdio.h>
#include <vector>
#include <set>
#include <math.h>

using namespace std;

#define KMAX 317
#define GMAX 1001
#define NMAX 100001

vector<int> pos[NMAX], posg[GMAX], elemsg[GMAX];
set<int> selemsg[GMAX], sposg[GMAX];
set<int>::iterator itpos, itelems;
int n, m, i, j, k, p, g, ans, leftg, gmax;

int getGroup(int x) {
	return x / KMAX;
	/*
	if (x == 1)
		return 0;
	return (int) (sqrt(2 * x)) - 1;
	*/
	
/*
	int group = -1;
	while (x > 0) {
		group++;
		x >>= 1;
	}
	return group;
*/
}

int main() {
	scanf("%d %d", &n, &m);
	for (i = 1; i <= n; i++) {
		scanf("%d", &j);
		if (j < NMAX) {
			pos[j].push_back(i);
			g = getGroup(j);
			sposg[g].insert(i);
			selemsg[g].insert(j);
		}
	}
	
	for (i = 1; i < NMAX; i++)
		if (pos[i].size() < i) {
			g = getGroup(i);
			selemsg[g].erase(i);
			for (j = 0; j < pos[i].size(); j++)
				sposg[g].erase(pos[i][j]);
			pos[i].clear();
		}

	gmax = getGroup(NMAX - 1) + 1;

	for (g = 0; g < gmax; g++) {
		for (itpos = sposg[g].begin(); itpos != sposg[g].end(); itpos++)
			posg[g].push_back(*itpos);
		sposg[g].clear();
		
		for (itelems = selemsg[g].begin(); itelems != selemsg[g].end(); itelems++)
			elemsg[g].push_back(*itelems);
		selemsg[g].clear();
	}
		
	while (m--) {
		scanf("%d %d", &i, &j);
		ans = 0;
		
		for (g = 0; g < gmax; g++) {
			if (elemsg[g].size() == 0)
				continue;
			if (elemsg[g][0] > j - i + 1)
				break;
			
			int li = 0, ls = posg[g].size() - 1, mid, pleft = posg[g].size(), pright = -1;
			while (li <= ls) {
				mid = (li + ls) / 2;
				if (posg[g][mid] >= i) {
					pleft = mid;
					ls = mid - 1;
				} else {
					li = mid + 1;
				}
			}

			li = 0; ls = posg[g].size() - 1;
			while (li <= ls) {
				mid = (li + ls) / 2;
				if (posg[g][mid] <= j) {
					pright = mid;
					li = mid + 1;
				} else {
					ls = mid - 1;
				}
			}

			if (pleft <= pright && posg[g][pleft] <= j && posg[g][pright] >= i) {
				leftg = pright - pleft + 1;
			} else
				continue;

			for (p = 0; p < elemsg[g].size(); p++) {
				k = elemsg[g][p];
				if (k > leftg)
					break;
				
				li = 0; ls = pos[k].size() - 1; pleft = pos[k].size(), pright = -1;
				while (li <= ls) {
					mid = (li + ls) / 2;
					if (pos[k][mid] >= i) {
						pleft = mid;
						ls = mid - 1;
					} else {
						li = mid + 1;
					}
				}

				li = 0, ls = pos[k].size() - 1;
				while (li <= ls) {
					mid = (li + ls) / 2;
					if (pos[k][mid] <= j) {
						pright = mid;
						li = mid + 1;
					} else {
						ls = mid - 1;
					}
				}

				if (pleft <= pright && pos[k][pleft] <= j && pos[k][pright] >= i) {
					leftg -= (pright - pleft + 1);
					if (pright - pleft + 1 == k)
						ans++;
				}
			}
		}
		
		printf("%d\n", ans);
	}
	
	return 0;
}
