#include <stdio.h>
#include <string.h>
#include <vector>

using namespace std;

#define NMAX 20

int xd[NMAX], dd[NMAX];
int x;

void getDigits(int n, int *nd) {
	memset(nd, 0, 10 * sizeof(int));
	while (n > 0) {
		nd[n % 10]++;
		n /= 10;
	}
}

int testDivisor (int d) {
	getDigits(d, dd);
	for (int i = 0; i < 10; i++)
		if (xd[i] > 0 && dd[i] > 0)
			return 1;
	return 0;
}

int numGoodDivisors(int x) {
	int result = 0;
	for (int i = 1; i * i <= x; i++) {
		if (x % i == 0) {
			result += testDivisor(i);
			if (i * i != x) {
				result += testDivisor(x / i);
			}
		}
	}
	return result;
}

int main() {
	scanf("%d", &x);
	getDigits(x, xd);
	printf("%d\n", numGoodDivisors(x));
	return 0;
}
