#include <stdio.h>
#include <string.h>

#define MMAX 55
#define BMAX 63
#define MOD 1000000007

long long A[MMAX][MMAX], T[MMAX][MMAX], Taux[MMAX][MMAX], answer;

char s[10];
long long N, bit[BMAX];
int M, K, x, y, i, j, k;

int main() {
	//freopen("222e.txt", "r", stdin);
	scanf("%I64d %d %d", &N, &M, &K);
	
	memset(A, 0, sizeof(A));
	for (i = 1; i <= M; i++)
		for (j = 1; j <= M; j++)
			A[i][j] = 1;
		
	while (K--) {
		scanf(" %s", s);
		if (s[0] >= 'a' && s[0] <= 'z')
			x = s[0] - 'a' + 1;
		else
			x = s[0] - 'A' + 27;
		if (s[1] >= 'a' && s[1] <= 'z')
			y = s[1] - 'a' + 1;
		else
			y = s[1] - 'A' + 27;
		A[x][y] = 0;
	}
	
	bit[0] = 1;
	for (i = 1; i < BMAX; i++)
		bit[i] = bit[i - 1] * 2LL;

	memset(T, 0, sizeof(T));
	for (i = 1; i <= M; i++)
		T[i][i] = 1;
		
	N--;	
	for (x = BMAX - 1; x >= 0; x--) {
		memset(Taux, 0, sizeof(Taux));
		for (i = 1; i <= M; i++)
			for (j = 1; j <= M; j++)
				for (k = 1; k <= M; k++)
					Taux[i][j] = (Taux[i][j] + T[i][k] * T[k][j]) % MOD;

		for (i = 1; i <= M; i++)
			for (j = 1; j <= M; j++)
				T[i][j] = Taux[i][j];

		if ((N & bit[x]) > 0) {
			memset(Taux, 0, sizeof(Taux));
			for (i = 1; i <= M; i++)
				for (j = 1; j <= M; j++)
					for (k = 1; k <= M; k++) {
						answer = (T[i][k] * A[k][j]) % MOD;
						Taux[i][j] = (Taux[i][j] + answer) % MOD;
					}
					
			for (i = 1; i <= M; i++)
				for (j = 1; j <= M; j++)
					T[i][j] = Taux[i][j];
		}
	}

	answer = 0;
	for (i = 1; i <= M; i++)
		for (j = 1; j <= M; j++)
			answer = (answer + T[i][j]) % MOD;
	
	printf("%I64d\n", answer);

	return 0;
}
