#include <string.h>
#include <vector>
#include <algorithm>

using namespace std;

#define NMAX 200200

char s[NMAX], t[NMAX];
vector<pair<int, int> > intv[30];
int pmin[NMAX], pmax[NMAX];
int M, N, i, j, k, nosol;

int main() {
	//freopen("223b.txt", "r", stdin);
	
	fgets(s, NMAX - 2, stdin);
	fgets(t, NMAX - 2, stdin);
	M = strlen(s);
	N = strlen(t);
	
	fprintf(stderr, "M=%d\nN=%d\n", M, N);
	
	i = j = 0;
	while (i < M && j < N) {
		if (s[i] == t[j]) {
			pmin[j] = i;
			j++;
		}
		i++;
	}

	if (j < N) {
		printf("No\n");
		return 0;
	}
	
	i = M - 1; j = N - 1;;
	while (i >= 0 && j >= 0) {
		if (s[i] == t[j]) {
			pmax[j] = i;
			j--;
		}
		i--;
	}

	for (j = 0; j < N; j++)
		if (t[j] >= 'a' && t[j] <= 'z')
			intv[t[j] - 'a'].push_back(make_pair(pmin[j], pmax[j]));

	nosol = 0;
	for (k = 0; k <= 'z' - 'a' && !nosol; k++) {
		sort(intv[k].begin(), intv[k].end());
		i = 0; j = 0;
		int xmax = -1;
		
		while (i < M) {
			if (s[i] != (char) (k + 'a'))
				i++;
			else {
				if (i <= xmax)
					i++;
				else {
					if (j < intv[k].size()) {
						if (i < intv[k][j].first) {
							nosol = 1;
							break;
						}
						if (intv[k][j].second > xmax)
							xmax = intv[k][j].second;
						j++;
					} else {
						nosol = 1;
						break;
					}
				}
			}
		}
	}
	
	if (nosol)
		printf("No\n");
	else
		printf("Yes\n");
	
	return 0;
}
