#include <stdio.h>
#include <string.h>

#define BMAX 32

long long T[2][2] = { {3, 2}, {0, 1} };
long long Trez[2][2], Taux[2][2];
int bit[BMAX];
int N, M, i, j, k, b;

int main() {
	bit[0] = 1;
	for (i = 1; i < BMAX; i++)
		bit[i] = bit[i - 1] << 1;

	scanf("%d %d", &N, &M);

	Trez[0][0] = Trez[1][1] = 1;
	Trez[0][1] = Trez[1][0] = 0;
	
	for (b = BMAX - 1; b >= 0; b--) {
		memset(Taux, 0, sizeof(Taux));
		for (i = 0; i < 2; i++)
			for (j = 0; j < 2; j++)
				for (k = 0; k < 2; k++)
					Taux[i][j] = (Taux[i][j] + Trez[i][k] * Trez[k][j]) % M;
		memcpy(Trez, Taux, sizeof(Trez));

		if ((N & bit[b]) > 0) {
			memset(Taux, 0, sizeof(Taux));
			for (i = 0; i < 2; i++)
				for (j = 0; j < 2; j++)
					for (k = 0; k < 2; k++)
						Taux[i][j] = (Taux[i][j] + Trez[i][k] * T[k][j]) % M;
			memcpy(Trez, Taux, sizeof(Trez));			
		}		
	}

	printf("%d\n", (int) (Trez[0][1]));
	return 0;
}
