#include <stdio.h>

#define NMAX 100100

double p[NMAX], pstart[NMAX], s1pstart[NMAX], s2pstart[NMAX], s3pstart[NMAX];
double answer, score;
int N, i, j;

int main() {
	scanf("%d", &N);
	for (i = 1; i <= N; i++)
		scanf("%lf", &p[i]);
	p[0] = p[N + 1] = 0.0;
	
	answer = 0.0;
	s1pstart[0] = s2pstart[0] = s3pstart[i] = 0.0;
	
	for (i = 1; i <= N + 1; i++) {
		score = (double) i * (double) i * s1pstart[i - 1];
		score += s3pstart[i - 1];
		score -= 2.0 * (double) i * s2pstart[i - 1];
		score *= (1.0 - p[i]);
		answer += score;

		s1pstart[i - 1] *= p[i];
		s2pstart[i - 1] *= p[i];
		s3pstart[i - 1] *= p[i];
		
		/*
		for (j = 1; j < i; j++) {
			score = (double) (i - j) * (double) (i - j) * pstart[j] * (1.0 - p[i]);
			//fprintf(stderr, "%d-%d : prob=%.6lf, contrib=%.6lf\n", j, i - 1, pstart[j], score);
			answer += score;
			pstart[j] *= p[i];
		}
		*/

		pstart[i] = (1.0 - p[i - 1]) * p[i];
		s1pstart[i] = s1pstart[i - 1] + pstart[i];
		s2pstart[i] = s2pstart[i - 1] + pstart[i] * i;
		s3pstart[i] = s3pstart[i - 1] + pstart[i] * (double) i * (double) i;
	}
	
	printf("%.12lf\n", answer);
	return 0;
}
