#include <stdio.h>
#include <vector>

using namespace std;

#define NMAX 3001

vector<pair<int, int> > vec[NMAX];
char visited[NMAX];
int nmin[NMAX][3];
int N, i, j, k, root;

void dfs(int i) {
	visited[i] = 1;
	nmin[i][0] = nmin[i][1] = nmin[i][2] = 0;

	for (int k = 0; k < vec[i].size(); k++) {
		int j = vec[i][k].first;
		int c = vec[i][k].second;

		if (!visited[j]) {
			dfs(j);
			nmin[i][2] = min(nmin[i][2] + nmin[j][0] + c, nmin[i][0] + nmin[j][2] + 1 - c);
			nmin[i][1] = min(nmin[i][0] + nmin[j][2], nmin[i][1] + nmin[j][0] + c);
			nmin[i][1] = min(nmin[i][1], nmin[i][0] + nmin[j][1] + c);
			nmin[i][0] += nmin[j][0] + c;
		}
	}
}

int main() {
	scanf("%d", &N);
	for (k = 1; k < N; k++) {
		scanf("%d %d", &i, &j);
		vec[i].push_back(make_pair(j, 0));
		vec[j].push_back(make_pair(i, 1));
	}

	int answer = N - 1;
	for (root = 1; root <= N; root++) {
		memset(visited, 0, sizeof(visited));
		dfs(root);
		answer = min(answer, min(nmin[root][0], nmin[root][1]));
	}
	
	printf("%d\n", answer);	
	return 0;
}
