#include <stdio.h>
#include <string.h>
#include <algorithm>

using namespace std;

#define NMAX 201
#define AMAX 40001
#define INF 1000000000

int h[NMAX], sh[NMAX], cmin[NMAX][AMAX][2];
int N, a, b, i, j, k, sum;

int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	scanf("%d %d %d", &N, &a, &b);

	sh[0] = h[0] = 0;
	for (i = 1; i <= N; i++) {
		scanf("%d", &h[i]);
		sh[i] = sh[i - 1] + h[i];
	}

	cmin[0][0][0] = cmin[0][0][1] = 0;
	for (i = 1; i <= a; i++)
		for (k = 0; k < 2; k++)
			cmin[0][i][k] = INF;
	
	for (i = 1; i <= N; i++) {
		for (j = 0; j <= a; j++) {
			cmin[i][j][0] = cmin[i][j][1] = INF;
			if (sh[i] - j <= b) {
				cmin[i][j][1] = min(cmin[i][j][1], cmin[i - 1][j][1]);
				cmin[i][j][1] = min(cmin[i][j][1], cmin[i - 1][j][0] + min(h[i - 1], h[i]));
				//fprintf(stderr, "%d %d 1: %d\n", i, j, cmin[i][j][1]);
			}
		}
		
		for (j = 0; j <= a - h[i]; j++) {
			if (sh[i] - (j + h[i]) <= b) {
				cmin[i][j + h[i]][0] = min(cmin[i][j + h[i]][0], cmin[i - 1][j][0]);
				cmin[i][j + h[i]][0] = min(cmin[i][j + h[i]][0], cmin[i - 1][j][1] + min(h[i - 1], h[i]));
				//fprintf(stderr, "%d %d 0: %d\n", i, j, cmin[i][j][0]);
			}
		}
	}

	int answer = INF;
	for (j = 0; j <= a; j++)
		for (k = 0; k < 2; k++)
			answer = min(answer, cmin[N][j][k]);
		
	if (answer == INF)
		printf("-1\n");
	else
		printf("%d\n", answer);
		
	return 0;
}
