#include <stdio.h>
#include <string.h>
#include <algorithm>
#include <vector>

using namespace std;

#define NMAX 1001

vector<int> players[NMAX];
vector<int> group[2][NMAX];
int ngr[2];
int M, N, i, j, k, c, a;

int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	scanf("%d", &N);
	M = 0;
	
	ngr[0] = 1;
	for (i = 1; i <= N; i++)
		group[0][0].push_back(i);
	c = 0;
	
	while (1) {
		a = c;
		c = 1 - c;
		
		for (i = 0; i < ngr[c]; i++)
			group[c][i].clear();

		int still_play = 0;
		for (i = 0; i < ngr[a]; i++)
			if (group[a][i].size() > 1) {
				still_play = 1;
				break;
			}
			
		if (!still_play)
			break;
		
		ngr[c] = 0;
		for (i = 0; i < ngr[a]; i++)
			if (group[a][i].size() > 1) {
				k = group[a][i].size() / 2;
				for (j = 0; j < k; j++) {
					players[M].push_back(group[a][i][j]);
					group[c][ngr[c]].push_back(group[a][i][j]);
				}
				ngr[c]++;
				
				for (j = k; j < group[a][i].size(); j++) {
					group[c][ngr[c]].push_back(group[a][i][j]);
				}
				ngr[c]++;
			}
		M++;
	}

	printf("%d\n", M);
	for (i = 0; i < M; i++) {
		printf("%d", players[i].size());
		for (j = 0; j < players[i].size(); j++)
			printf(" %d", players[i][j]);
		printf("\n");
	}
	
	return 0;
}
