// O(N^4)

#include <stdio.h>
#include <string.h>

#define NMAX 260
#define MOD 777777777

int N, K, i, j, k, p, a, c;
long long C[NMAX][NMAX], num[2][NMAX][NMAX], ans;

int main() {
	//freopen("x.txt", "r", stdin);
	scanf("%d %d", &N, &K);
	
	C[0][0] = 1;
	for (i = 1; i <= N; i++) {
		C[i][0] = 1;
		for (j = 1; j <= i; j++)
			C[i][j] = (C[i - 1][j] + C[i - 1][j - 1]) % MOD;
	}

	num[0][0][0] = 1;
	for (i = 1; i <= N; i++) {
		c = i % 2;
		a = 1 - c;
		memset(num[c], 0, sizeof(num[c]));
		for (j = 0; j <= N; j++)
			for (k = 0; k <= j && k <= K; k++) {
				if (j >= i)
					num[c][j][k] = (num[c][j][k] + num[a][j - i][k] * C[j][i]) % MOD;
				for (p = 0; p <= k; p++)
					if (p != i)
						num[c][j][k] = (num[c][j][k] + num[a][j - p][k - p] * C[j][p]) % MOD;
			}
	}
	
	ans = num[N % 2][N][K];
	printf("%I64d\n", ans);
	
	return 0;
}
