#include <stdio.h>
#include <math.h>
#include <vector>
#include <algorithm>

using namespace std;

#define NMAX 3001

vector<pair<long long, int> > v;
long long x[NMAX], y[NMAX], R[NMAX], F[NMAX];
long long Fmax[NMAX], djk, dlimit, FFmax;
int N, i, ii, j, k;

int main() {
    freopen("cercuri4.in", "r", stdin);
    scanf("%d", &N);
    for (i = 1; i <= N; i++) {
        scanf("%lld %lld %lld %lld", &x[i], &y[i], &R[i], &F[i]);
        v.push_back(make_pair(R[i], i));
    }

    sort(v.begin(), v.end());
    Fmax[v[0].second] = F[v[0].second];
    for (i = 1; i < N; i++) {
        j = v[i].second;
        Fmax[j] = 0;
        for (ii = i - 1; ii >= 0; ii--) {
            k = v[ii].second;
            if (Fmax[k] > Fmax[j]) {
                // Verifica daca cercul j in contine pe cercul k.
                djk = (x[j] - x[k]) * (x[j] - x[k]) + (y[j] - y[k]) * (y[j] - y[k]);
                dlimit = (R[j] - R[k]) * (R[j] - R[k]);
                if (djk <= dlimit)
                    Fmax[j] = Fmax[k];
            }
        }

        Fmax[j] += F[j];
    }

    freopen("cercuri4.out", "w", stdout);
    FFmax = Fmax[1];
    for (i = 2; i <= N; i++)
        if (Fmax[i] > FFmax)
            FFmax = Fmax[i];
    printf("%lld\n", FFmax);

    return 0;
}
