#include <stdio.h>
#include <stdlib.h>

#include <set>
#include <map>
#include <vector>

using namespace std;

#define NMAX 500100
#define KMAX 500100
#define VMAX 1000100

#define NSMALL 10

int touched[VMAX], ptouched[VMAX];
int ok[2][NMAX];
int v[NMAX], sol[NMAX], vmin, vmax, p1, p2, pvmin, pvmax;
//int* pred[NMAX];
vector<int> pred[NMAX];
map<pair<int, int>, int> predmap;

set<pair<int, int> > to_remove[2];
set<pair<int, int> >::iterator it;

char s[KMAX];
int N, K, c, a, L, i, poz, cntok, lastok;

int main() {
    freopen("fpwl.in", "r", stdin);
    scanf("%d %d", &N, &K);

    if (N > NMAX)
        return 1;

    for (i = 1; i <= N; i++)
        scanf("%d", &v[i]);

    for (i = 0; i < K; i++) {
        do {
            scanf("%c", &s[i]);
        } while (s[i] != '<' && s[i] != '=' && s[i] != '>');
    }

    if (K > N - 1)
        K = N - 1;

    for (i = 1; i <= N; i++)
        ok[1][i] = 1;

    p1 = 1;

    for (lastok = 1, poz = 0, L = 2; L <= N; L++) {
        c = L % 2;
        a = 1 - c;
        cntok = 0;
        vmin = VMAX;
        vmax = -1;
        pvmin = pvmax = 0;

        pred[L].push_back(0);
        //pred[L] = new int[N + 1];

        p2 = p1; p1 = 0;
        to_remove[c].clear();

        for (i = p2; i <= N; i++) {
            //pred[L].push_back(0);

            if (s[poz] == '=') {
                if (touched[v[i]] == L) {
                    ok[c][i] = L;
                    //pred[L][i] = ptouched[v[i]];
                    predmap[make_pair(L, i)] = ptouched[v[i]];
                    to_remove[c].insert(make_pair(L, i));
                    to_remove[a].erase(make_pair(L - 1, ptouched[v[i]]));
                    lastok = i;
                }
            } else if (s[poz] == '>') {
                if (vmax > v[i]) {
                    ok[c][i] = L;
                    //pred[L][i] = pvmax;
                    predmap[make_pair(L, i)] = pvmax;
                    to_remove[c].insert(make_pair(L, i));
                    to_remove[a].erase(make_pair(L - 1, pvmax));
                    lastok = i;
                }
            } else { // s[poz] == '<'
                if (vmin < v[i]) {
                    ok[c][i] = L;
                    //pred[L][i] = pvmin;
                    predmap[make_pair(L, i)] = pvmin;
                    to_remove[c].insert(make_pair(L, i));
                    to_remove[a].erase(make_pair(L - 1, pvmin));
                    lastok = i;
                }
            }

            if (ok[a][i] == L - 1) {
                touched[v[i]] = L;
                ptouched[v[i]] = i;
                if (v[i] < vmin) {
                    vmin = v[i];
                    pvmin = i;
                }
                if (v[i] > vmax) {
                    vmax = v[i];
                    pvmax = i;
                }
            }

            if (ok[c][i] == L) {
                if (!p1)
                    p1 = i;
                cntok++;
            }

            if (cntok >= NSMALL)
                break;
        }

        if (cntok == 0)
            break;

        poz = (poz + 1) % K;
        for (it = to_remove[a].begin(); it != to_remove[a].end(); it++) {
            predmap.erase(*it);
        }
    }

    freopen("fpwl.out", "w", stdout);
    L--;
    printf("%d\n", L);

    i = lastok;
    sol[K = L] = i;
    while (K > 1) {
        //i = pred[K][i];
        i = predmap[make_pair(K, i)];
        K--;
        sol[K] = i;
    }

    for (i = 1; i <= L; i++) {
        printf("%d", v[sol[i]]);
        if (i < L)
            printf(" ");
    }
    printf("\n");

    return 0;
}
