#include <stdio.h>
#include <string.h>

/*
(K P)   (D(j))   (D(j+1))
(P K) * (I(j)) = (I(j+1))
*/

#define MOD 666013
#define BMAX 63

long long T[2][2], Trez[2][2], Taux[2][2];
long long bit[BMAX], x, y;

#define BUFSIZE 1000000
char buf[BUFSIZE];
int bufpoz, buflen;

void read_next_int(int *x) {
	while (1) {
		if (bufpoz >= buflen) {
			fgets(buf, BUFSIZE - 3, stdin);
			bufpoz = 0;
			buflen = strlen(buf);
		}
		if (buf[bufpoz] >= '0' && buf[bufpoz] <= '9')
			break;
		if (buf[bufpoz] == '-')
			break;
		bufpoz++;
	}

	*x = 0;
	while (bufpoz < buflen && buf[bufpoz] >= '0' && buf[bufpoz] <= '9') {
		*x = (*x) * 10 + (buf[bufpoz] - '0');
		bufpoz++;
	}
}

void read_next_long_long(long long *x) {
	while (1) {
		if (bufpoz >= buflen) {
			fgets(buf, BUFSIZE - 3, stdin);
			bufpoz = 0;
			buflen = strlen(buf);
		}
		if (buf[bufpoz] >= '0' && buf[bufpoz] <= '9')
			break;
		if (buf[bufpoz] == '-')
			break;
		bufpoz++;
	}

	*x = 0;
	while (bufpoz < buflen && buf[bufpoz] >= '0' && buf[bufpoz] <= '9') {
		*x = (*x) * 10 + (buf[bufpoz] - '0');
		bufpoz++;
	}
}

int main() {
    int i, j, k, b, tests, K, P;
    long long N;

    bit[0] = 1;
    for (i = 1; i < BMAX; i++)
        bit[i] = bit[i - 1] * 2;

    freopen("invazie.in", "r", stdin);
    freopen("invazie.out", "w", stdout);

    bufpoz = buflen = 0;
    read_next_int(&tests);

    while (tests--) {
        read_next_int(&K);
        read_next_int(&P);
        read_next_long_long(&N);

        K %= MOD;
        P %= MOD;

        //T[0][0] = K; T[0][1] = P;
        //T[1][0] = P; T[1][1] = K;

        Trez[0][0] = 1; Trez[0][1] = 0;
        //Trez[1][0] = 0; Trez[1][1] = 1;

        b = BMAX - 1;
        while (b >= 0 && ((N & bit[b]) == 0))
            b--;

        for (; b >= 0; b--) {
            /*
            for (i = 0; i < 2; i++)
                for (j = 0; j < 2; j++) {
                    Taux[i][j] = 0;
                    for (k = 0; k < 2; k++)
                        Taux[i][j] = (Taux[i][j] + Trez[i][k] * Trez[k][j]) % MOD;
                }
            memcpy(Trez, Taux, sizeof(Taux));
            */

            x = Trez[0][0]; y = Trez[0][1];
            Trez[0][0] = (x * x + y * y) % MOD;
            Trez[0][1] = (x * y * 2) % MOD;

            if (N & bit[b]) {
                /*
                for (i = 0; i < 2; i++)
                    for (j = 0; j < 2; j++) {
                        Taux[i][j] = 0;
                        for (k = 0; k < 2; k++)
                            Taux[i][j] = (Taux[i][j] + Trez[i][k] * T[k][j]) % MOD;
                    }
                memcpy(Trez, Taux, sizeof(Taux));
                */
                x = Trez[0][0]; y = Trez[0][1];
                Trez[0][0] = (x * K + y * P) % MOD;
                Trez[0][1] = (x * P + y * K) % MOD;
            }
        }

        printf("%lld\n", Trez[0][0]);
    }

    return 0;
}
