#include <stdio.h>
#include <string.h>

#define NMAX 101000
#define BUFSIZE 10000000

char sir[NMAX], buf[BUFSIZE];
int stk[NMAX], ans[NMAX], slen, bufpoz, buflen;
int M, x;

void read_next_int(int *x) {
	while (1) {
		if (bufpoz >= buflen) {
			fgets(buf, BUFSIZE - 3, stdin);
			bufpoz = 0;
			buflen = strlen(buf);
		}
		if (buf[bufpoz] >= '0' && buf[bufpoz] <= '9')
			break;
		if (buf[bufpoz] == '-')
			break;
		bufpoz++;
	}

	*x = 0;
	while (bufpoz < buflen && buf[bufpoz] >= '0' && buf[bufpoz] <= '9') {
		*x = (*x) * 10 + (buf[bufpoz] - '0');
		bufpoz++;
	}
}

void compute_answers() {
    int i, niv = 0;
    for (i = 0; i < slen; i++) {
        if (sir[i] == '(') {
            niv++;
            stk[niv] = i;
        } else if (sir[i] == ')') {
            ans[stk[niv]] = i;
            niv--;
        }
    }
}

int main() {
    freopen("parantezare.in", "r", stdin);
    freopen("parantezare.out", "w", stdout);

    fgets(sir, NMAX - 2, stdin);
    slen = strlen(sir);

    compute_answers();

    bufpoz = buflen = 0;
    read_next_int(&M);
    while (M--) {
        read_next_int(&x);
        printf("%d", ans[x]);
        if (M > 0)
            printf(" ");
    }
    printf("\n");
    return 0;
}
