#include <stdio.h>
#include <vector>

using namespace std;

int N, M, A, B, C, D, E, i, x, cnt;

#define Q 12809
vector<int> h[2][Q];

inline int InHash(int hidx, int x) {
	int hx = x % Q;
	for (int i = 0; i < h[hidx][hx].size(); i++)
		if (h[hidx][hx][i] == x)
			return 1;
	return 0;
}

int main() {
	freopen("muzica.in", "r", stdin);
	scanf("%d %d %d %d %d %d %d", &N, &M, &A, &B, &C, &D, &E);
	for (i = 0; i < N; i++) {
		scanf("%d", &x);
		h[0][x % Q].push_back(x);
	}
	
	if (InHash(0, A)) {
		h[1][A % Q].push_back(A);
	}
	if (A != B && InHash(0, B)) {
		h[1][B % Q].push_back(B);
	}
	
	for (i = 3; i <= M; i++) {
		x = ((long long) C * (long long) B + (long long) D * (long long) A) % E;

		if (InHash(0, x) && !InHash(1, x))
			h[1][x % Q].push_back(x);
		
		A = B;
		B = x;
	}
	
	freopen("muzica.out", "w", stdout);

	cnt = 0;
	for (i = 0; i < Q; i++)
		cnt += h[1][i].size();
	printf("%d\n", cnt);
	
	return 0;
}
