#include <stdio.h>
#include <string.h>
#include <vector>

using namespace std;

#define NMAX 5010

vector<int> v[NMAX];
char marked[NMAX], xmarked[NMAX], visited[NMAX];
int cnt[NMAX];
int N, i, j, k, np;

void dfs(int x) {
	vector<int> vv;
	visited[x] = 1;
	cnt[x] = 1;

	for (int y = 0; y < v[x].size(); y++) {
		int z = v[x][y];
		if (!visited[z]) {
			dfs(z);
			cnt[x] += cnt[z];
			vv.push_back(cnt[z]);
		}
	}

	vv.push_back(N - cnt[x]);

	memset(xmarked, 0, sizeof(xmarked));
	xmarked[0] = 1;
	for (i = 0; i < vv.size(); i++)
		for (j = N - 1 - vv[i]; j >= 0; j--)
			if (xmarked[j])
				xmarked[j + vv[i]] = 1;

	for (i = 1; i < N - 1; i++)
		if (xmarked[i]) {
			marked[i] = marked[N - 1 - i] = 1;
		}
}

int main() {
	//freopen("x.txt", "r", stdin);
	scanf("%d", &N);
	for (k = 1; k < N; k++) {
		scanf("%d %d", &i, &j);
		v[i].push_back(j);
		v[j].push_back(i);
	}
	
	dfs(1);
	
	np = 0;
	for (i = 1; i < N - 1; i++)
		if (marked[i])
			np++;

	printf("%d\n", np);
	for (i = 1; i < N - 1; i++)
		if (marked[i])
			printf("%d %d\n", i, N - 1 - i);
	
	return 0;
}
