#include <stdio.h>
#include <string.h>

#define NMAX 101

int A[NMAX][NMAX], sumrow[NMAX], sumcol[NMAX];
char selrow[NMAX], selcol[NMAX];
int M, N, i, j, changed;

int main() {
	//freopen("x.txt", "r", stdin);
	scanf("%d %d", &M, &N);
	for (i = 1; i <= M; i++)
		for (j = 1; j <= N; j++)
			scanf("%d", &A[i][j]);

	for (i = 1; i <= M; i++) {
		sumrow[i] = 0;
		for (j = 1; j <= N; j++)
			sumrow[i] += A[i][j];
	}
	
	for (j = 1; j <= N; j++) {
		sumcol[j] = 0;
		for (i = 1; i <= M; i++)
			sumcol[j] += A[i][j];
	}
		
	memset(selrow, 0, sizeof(selrow));
	memset(selcol, 0, sizeof(selcol));

	changed = 1;
	while (changed) {
		changed = 0;
		for (i = 1; i <= M; i++)
			if (sumrow[i] < 0) {
				selrow[i] = 1 - selrow[i];
				sumrow[i] = -sumrow[i];
				for (j = 1; j <= N; j++) {
					sumcol[j] -= A[i][j];
					A[i][j] = -A[i][j];
					sumcol[j] += A[i][j];
				}
				changed = 1;
			}

		for (j = 1; j <= N; j++)
			if (sumcol[j] < 0) {
				selcol[j] = 1 - selcol[j];
				sumcol[j] = -sumcol[j];
				for (i = 1; i <= M; i++) {
					sumrow[i] -= A[i][j];
					A[i][j] = -A[i][j];
					sumrow[i] += A[i][j];
				}
				changed = 1;
			}
	}

	int cnt = 0;
	for (i = 1; i <= M; i++)
		cnt += selrow[i];
	printf("%d", cnt);
	for (i = 1; i <= M; i++)
		if (selrow[i])
			printf(" %d", i);
	printf("\n");

	cnt = 0;
	for (i = 1; i <= N; i++)
		cnt += selcol[i];
	printf("%d", cnt);
	for (i = 1; i <= N; i++)
		if (selcol[i])
			printf(" %d", i);
	printf("\n");
	
	return 0;
}
