#include <stdio.h>
#include <string.h>
#include <algorithm>

using namespace std;

#define NROWS 101
#define NCOLUMNS 10010

char A[NROWS][NCOLUMNS];
int dleft[NROWS], dright[NROWS];
int M, N, i, j, k, cnt;
int answer, canswer;

int main() {
	//freopen("x.txt", "r", stdin);
	scanf("%d %d ", &M, &N);
	for (i = 1; i <= M; i++)
		fgets(&A[i][1], NCOLUMNS - 2, stdin);
	
	answer = -1;
	for (j = 1; j <= N; j++) {
		canswer = 0;
		for (i = 1; i <= M; i++) {
			if (j == 1 || A[i][j] == '1') {
				k = j; dleft[i] = 0;
				while (A[i][k] != '1' && dleft[i] <= N) {
					k--;
					dleft[i]++;
					if (k <= 0)
						k = N;
				}

				if (dleft[i] > N) {
					canswer = -1;
					break;
				}
				
				k = j + 1; dright[i] = 1;
				if (k > N)
					k = 1;
				while (A[i][k] != '1' && dright[i] <= N) {
					k++;
					dright[i]++;
					if (k > N)
						k = 1;
				}

				if (dright[i] > N) {
					canswer = -1;
					break;
				}

			} else {
				dleft[i]++;
				dright[i]--;
			}
	
			//fprintf(stderr, "j=%d, i=%d, dleft[i]=%d, dright[i]=%d\n", j, i, dleft[i], dright[i]);
			canswer += min(dleft[i], dright[i]);
		}
		
		if (canswer < 0)
			break;
		
		if (answer < 0 || canswer < answer)
			answer = canswer;
	}
	
	printf("%d\n", answer);
	
	return 0;
}
