#include <stdio.h>
#include <string.h>
#include <algorithm>
#include <vector>

using namespace std;

#define NMAX 100001

int a[2 * NMAX], c[2 * NMAX];
int sint[NMAX], face[NMAX], nint;
int M, N, i, j, k, x, nok;

int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	scanf("%d", &M);
	for (i = 1; i <= M; i++)
		scanf("%d", &a[i]);
	scanf("%d", &N);
	for (i = M + 1; i <= M + N; i++)
		scanf("%d", &a[i]);
	a[M + N + 1] = 0;
		
	// Merge
	i = M; j = M + N; k = 0; c[0] = M + N + 1;
	while (i >= 1 && j > M) {
		if (a[i] == a[c[k]]) {
			k++; c[k] = i; i--;
		} else if (a[j] == a[c[k]]) {
			k++; c[k] = j; j--;
		} else {
			// a[i] == a[j] && different from a[c[k]].
			k++; c[k] = i; i--;
			k++; c[k] = j; j--;
		}
	}

	for (; i >= 1; i--) {
		k++; c[k] = i;
	}

	for (; j > M; j--) {
		k++; c[k] = j;
	}
	
	for (k = M + N; k >= 1; k--) {
		printf("%d", c[k]);
		if (k > 1)
			printf(" ");
	}
	printf("\n");

	nok = 0;
	while (nok < M + N && a[c[nok + 1]] == 0)
		nok++;

	nint = 0;
	for (k = nok + 1; k <= M + N; k++) {
		if (a[c[k]] == a[c[k - 1]])
			sint[nint]++;
		else {
			nint++;
			sint[nint] = 1;
			face[nint] = a[c[k]];
		}
	}
	
	printf("%d\n", nint);
	i = 1; j = nint; k = 1; x = 0;
	int first = 1;
	while (i <= j) {
		if (k == 0) {
			// The top is at i.
			if ((face[i] ^ x) == 0) {
				if (!first)
					printf(" ");
				first = 0;
				printf("%d", sint[i]);
				sint[i + 1] += sint[i];
				i++;
			} else {
				if (!first)
					printf(" ");
				first = 0;
				printf("%d", M + N - nok);
				nok += sint[i];
				i++;
				x ^= 1;
				k = 1;
			}
		} else {
			// The top is at j.
			if ((face[j] ^ x) == 0) {
				if (!first)
					printf(" ");
				first = 0;
				printf("%d", sint[j]);
				sint[j - 1] += sint[j];
				j--;
			} else {
				if (!first)
					printf(" ");
				first = 0;
				printf("%d", M + N - nok);
				nok += sint[j];
				j--;
				x ^= 1;
				k = 0;
			}
		}
	}
	
	if (!first)
		printf("\n");
	
	return 0;
}