#include <stdio.h>
#include <string.h>
#include <vector>

using namespace std;

#define NMAX 2001
#define MMAX 10001

vector<pair<int, int> > next[NMAX], prev[NMAX];
int tmax[NMAX], target[NMAX], q[NMAX], degin[NMAX];
int len[MMAX], v1[NMAX], vn[NMAX];
int N, M, i, j, k, p, li, ls;

int main() {
	//freopen("input.txt", "r", stdin);
	scanf("%d %d", &N, &M);
	for (k = 1; k <= M; k++) {
		scanf("%d %d", &i, &j);
		next[i].push_back(make_pair(j, k));
		prev[j].push_back(make_pair(i, k));
		len[k] = 1;
	}

	q[k = li = ls = 1] = N;
	memset(vn, 0, sizeof(vn));
	vn[N] = 1;
	while (li <= ls) {
		i = q[li];
		for (k = 0; k < prev[i].size(); k++) {
			j = prev[i][k].first;
			if (!vn[j]) {
				ls++;
				q[ls] = j;
				vn[j] = 1;
			}
		}
		li++;
	}

	q[k = li = ls = 1] = 1;
	memset(v1, 0, sizeof(v1));
	v1[1] = 1;
	while (li <= ls) {
		i = q[li];
		for (k = 0; k < next[i].size(); k++) {
			j = next[i][k].first;
			if (!v1[j]) {
				ls++;
				q[ls] = j;
				v1[j] = 1;
			}
		}
		li++;
	}

	for (i = 1; i <= N; i++)
		if (v1[i] && vn[i]) {
			degin[i] = 0;
			for (j = 0; j < prev[i].size(); j++)
				if (v1[prev[i][j].first] && vn[prev[i][j].first])
					degin[i]++;
		} else
			degin[i] = N + 1;

	q[k = li = ls = 1] = 1;
	while (li <= ls) {
		i = q[li];
		for (k = 0; k < next[i].size(); k++) {
			j = next[i][k].first;
			degin[j]--;
			if (v1[j] && vn[j] && degin[j] == 0) {
				ls++;
				q[ls] = j;
			}
		}
		li++;
	}
	
	tmax[1] = target[1] = 0;
	for (k = 2; k <= ls; k++) {
		i = q[k];
		tmax[i] = 0;
		for (p = 0; p < prev[i].size(); p++) {
			j = prev[i][p].first;
			if (!v1[j] || !vn[j])
				continue;
			if (tmax[j] + 1 > tmax[i])
				tmax[i] = tmax[j] + 1;
		}
		target[i] = tmax[i];
	}

	//int limit = target[N];
	//for (; target[N] <= limit; target[N]++) {
	for (k = 1; k < ls; k++)
		target[q[k]] = tmax[q[k]];

	int changed = 1, ok = 1;
	while (changed && ok) {
		changed = 0;
		for (k = ls; k >= 1; k--) {
			i = q[k];
			for (p = 0; p < prev[i].size(); p++) {
				j = prev[i][p].first;
				if (!v1[j] || !vn[j])
					continue;
				if (target[j] < target[i] - 2) {
					target[j] = target[i] - 2;
					changed = 1;
				}
			}
		}

		for (k = 1; k < ls && ok; k++) {
			i = q[k];
			for (p = 0; p < next[i].size(); p++) {
				j = next[i][p].first;
				if (!v1[j] || !vn[j])
					continue;
				if (target[j] <= target[i]) {
					target[j] = target[i] + 1;
					if (target[j] >= 2 * N) {
						ok = 0;
					}
					changed = 1;
				}
			}
		}
	}

	for (i = 1; i <= N && ok; i++)
		if (v1[i] && vn[i]) {
			for (j = 0; j < prev[i].size() && ok; j++)
				if (v1[prev[i][j].first] && vn[prev[i][j].first]) {
					len[prev[i][j].second] = target[i] - target[prev[i][j].first];
					if (len[prev[i][j].second] <= 0 || len[prev[i][j].second] >= 3) {
						ok = 0;
					}
				}
		}


	if (target[1] > 0 || !ok) {
		printf("No\n");
		return 0;
	}
	
	printf("Yes\n");	
	for (k = 1; k <= M; k++)
		printf("%d\n", len[k]);
	return 0;
}
