#include <stdio.h>
#include <algorithm>
#include <math.h>

using namespace std;

#define NMAX 1001

double x[NMAX], p[NMAX], R[NMAX];
int s[NMAX], niv, nivmax, lrelax;

void Relax(int i, int j) {
	double xx = (x[i] - x[j]) * (x[i] - x[j]) / (4.0 * R[j]);
	if (xx < R[i]) {
		R[i] = xx;
		lrelax = j;
	}
}

int N, i, j;

int main() {
	N = 500;
	x[1] = 0;
	p[1] = R[1] = 1000000;
	s[niv = 1] = 1;
	nivmax = 1;

	for (i = 2; i < N; i++) {
		int d = 4 * (N - i);
		if (d < 1)
			d = 1;
		x[i] = x[i - 1] + d;

		if (i <= 499) {
			p[i] = 500 - i;
			if (i == 2)
				x[i] = 1000;
			else
				x[i] = x[i - 1] + 4 * i; //(int)(p[i - 1]) + (int)(p[i]);
		} else
			p[i] = 1000000;
	}
	
	x[N] = 1000000;
	p[N] = 1000000;

	printf("%d\n", N);
	for (i = 1; i <= N; i++)
		printf("%d %d\n", (int) x[i], (int) p[i]);

	return 0;

/*	
	fprintf(stderr, "xmax=%.6lf\n", x[N]);
	
	for (i = 2; i <= N; i++) {
		R[i] = p[i];
		lrelax = 0;
		for (j = 1; j < i; j++)
			Relax(i, j);
		double Rok = R[i];
		int lrelaxok = lrelax;
		
		lrelax = 0;
		R[i] = p[i];
		for (j = niv; j >= 1 && j >= niv - 299; j--)
			Relax(i, s[j]);
		while (niv > 0 && R[s[niv]] <= R[i])
			niv--;
		niv++;
		s[niv] = i;
		
		if (niv > nivmax)
			nivmax = niv;
		
		fprintf(stderr, "i=%d: x=%.6lf Rok=%.6lf lrelaxok=%d R=%.6lf lrelax=%d niv=%d\n", i, x[i], Rok, lrelaxok, R[i], lrelax, niv);
		if (fabs(Rok - R[i]) > 1e-5) {
			fprintf(stderr, "!!! i=%d: Rok=%.6lf R[i]=%.6lf\n", i, Rok, R[i]);
		}
	}
	
	fprintf(stderr, "nivmax=%d\n", nivmax);
	
	return 0;
*/
}
