#include <stdio.h>
#include <algorithm>
#include <set>
#include <vector>

using namespace std;

#define BMAX 21
#define NMAX 100100

vector<pair<int, int> > poz;
set<int> answers;
set<int>::iterator it;
int pmax[BMAX];
int bit[BMAX];
int a[NMAX];
int N, i, j;

int main() {
	bit[0] = 1;
	for (i = 1; i < BMAX; i++)
		bit[i] = bit[i - 1] * 2;

	scanf("%d", &N);
	for (i = 1; i <= N; i++) {
		scanf("%d", &a[i]);
		
		poz.clear();
		for (j = 0; j < BMAX; j++) {
			if ((a[i] & bit[j]) > 0) {
				pmax[j] = i;
			}
			
			if (pmax[j] > 0)
				poz.push_back(make_pair(pmax[j], j));
		}

		sort(poz.begin(), poz.end());
		
		int num = a[i], cpoz = i;

		for (j = (int) (poz.size()) - 1; j >= 0; j--) {
			if (poz[j].first != cpoz) {
				answers.insert(num);
				cpoz = poz[j].first;
			}
			num |= bit[poz[j].second];
		}
		answers.insert(num);
	}

	printf("%d\n", answers.size());
	return 0;
}
