#include <stdio.h>

#define NMAX 10100

char A[NMAX], B[NMAX];
int prefix[NMAX];
int N, M, pozA, pozB, nextpozB, left, right, i, k;

int main() {
    freopen("potrivire.in", "r", stdin);
    scanf("%d %d", &N, &M);
    scanf("%s %s", A + 1, B + 1);

    right = pozB = 0;
    while ((pozB + 1 <= M) && B[pozB + 1] == '*')
        pozB++;

    freopen("potrivire.out", "w", stdout);
    if (pozB == M) {
        printf("1 1\n");
        return 0;
    }

    left = 0;
    while (1) {
        while ((pozB + 1 <= M) && B[pozB + 1] == '*')
            pozB++;
        if (pozB == M)
            break;

        nextpozB = pozB + 1;
        prefix[nextpozB] = k = nextpozB - 1;

        while ((nextpozB + 1 <= M) && B[nextpozB + 1] != '*') {
            nextpozB++;
            while (k > pozB && B[k + 1] != B[nextpozB])
                k = prefix[k];
            if (B[k + 1] == B[nextpozB])
                k++;
            prefix[nextpozB] = k;
        }

        //fprintf(stderr, "pozB=%d, nextpozB=%d\n", pozB, nextpozB);

        k = pozB;
        for (i = right + 1; i <= N; i++) {
            while (k > pozB && B[k + 1] != A[i])
                k = prefix[k];
            if (B[k + 1] == A[i])
                k++;
            if (k == nextpozB) {
                if (!right)
                    left = i - (nextpozB - pozB) + 1;
                right = i;
                break;
            }
        }

        if (i > N)
            break;

        pozB = nextpozB;
    }

    if (pozB < M)
        printf("-1\n");
    else
        printf("%d %d\n", left, right);

    return 0;
}
