#include <stdio.h>
#include <string.h>
#include <vector>
#include <algorithm>

using namespace std;

#define NMAX 100100

vector<pair<long long, pair<long long, int> > > v0;
long long A[NMAX], B[NMAX];
int N, i, j, k, M;
long long T, Tintersect;

int dq[NMAX];
long long Tbegin[NMAX];
int li, ls;

#define BUFSIZE 1000000
char buf[BUFSIZE];
int bufpoz, buflen, semn;

void read_next_int(int *x) {
	while (1) {
		if (bufpoz >= buflen) {
			fgets(buf, BUFSIZE - 3, stdin);
			bufpoz = 0;
			buflen = strlen(buf);
		}
		if (buf[bufpoz] >= '0' && buf[bufpoz] <= '9')
			break;
		if (buf[bufpoz] == '-')
			break;
		bufpoz++;
	}

	*x = 0;
	while (bufpoz < buflen && buf[bufpoz] >= '0' && buf[bufpoz] <= '9') {
		*x = (*x) * 10 + (buf[bufpoz] - '0');
		bufpoz++;
	}
}

void read_next_long_long(long long *x) {
	while (1) {
		if (bufpoz >= buflen) {
			fgets(buf, BUFSIZE - 3, stdin);
			bufpoz = 0;
			buflen = strlen(buf);
		}
		if (buf[bufpoz] >= '0' && buf[bufpoz] <= '9')
			break;
		if (buf[bufpoz] == '-')
			break;
		bufpoz++;
	}

    if (buf[bufpoz] == '-') {
        semn = -1;
        bufpoz++;
    } else {
        semn = +1;
    }

	*x = 0;
	while (bufpoz < buflen && buf[bufpoz] >= '0' && buf[bufpoz] <= '9') {
		*x = (*x) * 10 + (buf[bufpoz] - '0');
		bufpoz++;
	}

    if (semn < 0)
        *x = -(*x);
}

int main() {
    freopen("vmin.in", "r", stdin);
    bufpoz = buflen = 0;
    read_next_int(&N);
    read_next_int(&M);

    for (i = 1; i <= N; i++) {
        read_next_long_long(&A[i]);
        read_next_long_long(&B[i]);
        v0.push_back(make_pair(B[i], make_pair(A[i], i)));
    }

    sort(v0.begin(), v0.end());

    li = ls = 1;
    dq[1] = v0[0].second.second;
    Tbegin[1] = 0;

    for (i = 1; i < N; i++) {
        j = v0[i].second.second;
        if (A[j] >= A[dq[ls]])
            continue;

        while (ls >= 1) {
            k = dq[ls];
            Tintersect = (B[j] - B[k]) / (A[k] - A[j]);
            if (((B[j] - B[k]) % (A[k] - A[j])) > 0)
                Tintersect++;
            if (Tintersect > Tbegin[ls])
                break;
            ls--;
        }

        ls++;
        dq[ls] = j;

        if (ls > 1)
            Tbegin[ls] = Tintersect;
        else
            Tbegin[ls] = 0;
    }

    freopen("vmin.out", "w", stdout);
    while (M--) {
        read_next_long_long(&T);

        while (li < ls && T >= Tbegin[li + 1])
            li++;

        printf("%d", dq[li]);

        if (M > 0)
            printf(" ");
    }

    printf("\n");

    return 0;
}
