#include <stdio.h>

unsigned char headers[54];

char digits[10][6][6] = {
{
"11111",
"10001",
"10001",
"10001",
"11111",
},
{
"00001",
"00001",
"00001",
"00001",
"00001",
},
{
"11111",
"00001",
"11111",
"10000",
"11111",
},
{
"11111",
"00001",
"11111",
"00001",
"11111",
},
{
"10001",
"10001",
"11111",
"00001",
"00001",
},
{
"11111",
"10000",
"11111",
"00001",
"11111",
},
{
"11111",
"10000",
"11111",
"10001",
"11111",
},
{
"11111",
"00001",
"00001",
"00001",
"00001",
},
{
"11111",
"10001",
"11111",
"10001",
"11111",
},
{
"11111",
"10001",
"11111",
"00001",
"11111",
},
};

#define HEIGHT 16
#define WIDTH 64

unsigned char img[HEIGHT][WIDTH][3];
char A[HEIGHT][WIDTH];
int i, j, d, sum, p, q, ok;

int main() {
	FILE *f = fopen("captcha.in", "rb");
	fread(&headers, 54, 1, f);

	for (i = HEIGHT - 1; i >= 0; i--)
		for (j = 0; j < WIDTH; j++) {
			fread(&img[i][j], sizeof(unsigned char), 3, f);
			if (img[i][j][0] == 255 && img[i][j][1] == 255 && img[i][j][2] == 255)
				A[i][j] = '0';
			else
				A[i][j] = '1';
		}

	/*
	for (d = 0; d <= 9; d++) {
		for (p = 0; p < 5; p++) {
			for (q = 0; q < 5; q++)
				printf("%c", digits[d][p][q]);
			printf("\n");
		}
		printf("\n");
	}

	for (i = 0; i < HEIGHT; i++) {
		for (j = 0; j < WIDTH; j++)
			fprintf(stderr, "%c", A[i][j]);
		fprintf(stderr, "\n");
	}
	*/

	sum = 0;
	
	for (i = 0; i <= HEIGHT - 5; i++)
		for (j = 0; j <= WIDTH - 5; j++)
			for (d = 0; d <= 9; d++) {
				ok = 1;
				for (p = 0; p < 5; p++)
					for (q = 0; q < 5; q++)
						if (A[i + p][j + q] != digits[d][p][q])
							ok = 0;

				if (ok) {
					if (i > 0) {
						for (q = 0; q < 5; q++)
							if (A[i - 1][j + q] != '0') {
								ok = 0;
							}
					}
					if (i + 4 <= HEIGHT - 2) {
						for (q = 0; q < 5; q++)
							if (A[i + 5][j + q] != '0') {
								ok = 0;
							}
					}
					if (j > 0) {
						for (p = 0; p < 5; p++)
							if (A[i + p][j - 1] != '0') {
								ok = 0;
							}
					}
					if (j + 4 <= WIDTH - 2) {
						for (p = 0; p < 5; p++)
							if (A[i + p][j + 5] != '0') {
								ok = 0;
							}
					}
				}

				if (ok) {
					sum += d;
					//fprintf(stderr, "%d %d: %d\n", i, j, d);
				}
			}

	freopen("captcha.out", "w", stdout);
	printf("%d\n", sum);
	
	return 0;
}
