#include <stdio.h>
#include <string.h>
#include <vector>

using namespace std;

#define NMAX 100100

vector<int> out[NMAX], in[NMAX];
char visited[NMAX];
int p[NMAX], ctc[NMAX], degin[NMAX], degout[NMAX];
int N, M, i, j, cnt, nctc, nzdegin, nzdegout;

void dfout(int x) {
	int y;
	visited[x] = 1;
	for (y = 0; y < out[x].size(); y++)
		if (!visited[out[x][y]])
			dfout(out[x][y]);
	cnt++;
	p[cnt] = x;
}

void dfin(int x) {
	int y;
	visited[x] = 1;
	ctc[x] = nctc;
	for (y = 0; y < in[x].size(); y++)
		if (!visited[in[x][y]])
			dfin(in[x][y]);
}

int main() {
	freopen("drum4.in", "r", stdin);
	scanf("%d %d", &N, &M);
	while (M--) {
		scanf("%d %d", &i, &j);
		out[i].push_back(j);
		in[j].push_back(i);
	}
	
	cnt = 0;
	for (i = 1; i <= N; i++)
		if (!visited[i])
			dfout(i);
	
	nctc = 0;
	memset(visited, 0, sizeof(visited));
	for (i = N; i >= 1; i--)
		if (!visited[p[i]]) {
			nctc++;
			dfin(p[i]);
		}

	for (i = 1; i <= N; i++)
		for (j = 0; j < out[i].size(); j++)
			if (ctc[i] != ctc[out[i][j]]) {
				degout[ctc[i]]++;
				degin[ctc[out[i][j]]]++;
			}

	for (i = 1; i <= nctc; i++) {
		if (degin[i] == 0)
			nzdegin++;
		if (degout[i] == 0)
			nzdegout++;
	}
	
	fprintf(stderr, "%d %d %d\n", nctc, nzdegin, nzdegout);
	
	freopen("drum4.out", "w", stdout);
	if (nctc == 1) {
		printf("0\n");
	} else {
		printf("%d\n", max(nzdegin, nzdegout));
	}
	
	return 0;
}
